/*
 * IO.java
 *
 * Created on Nedea, 2007, aprl 29, 19:19
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package spectKonfo;

import javax.imageio.*;
import java.awt.image.*;
import java.io.*;



/**
 * Obsahuje funkcie potrebn na spracovanie vstupno/vstupnch operci.
 * @author Kamil
 */
public class IO {
    
    /**
     * Vytvor nov intanciu triedy IO.
     */
    public IO() {
    }
    
    
    /**
     * Nata obrzky zadan v poli s.
     * @param s Obsahuje cesty k jednotlivm obrzkom.
     * @return Vrti dvojrozmern pole typu char. Prv index oznauje slo obrzka, druh v druhom s jednotliv pixeli obrzka natan postupne po riadkoch. Hodnoty v poli s z rozsahu 0..255.
     */
    public static char[][] loadImages(String[] s) {
        
        int pixelCount; //pocet pixelov na obrazku a teda pocet vstupov
        int height, width;
        BufferedImage img = null;
        try {
            img = ImageIO.read(new File(s[0]));
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("Vstup nenajdeny");
            System.exit(0);
        }
        height = img.getHeight();
        width = img.getWidth();
        pixelCount = height * width;
        int n = s.length;
        char x[][] = new char[pixelCount][n];
        int i, j, k, l;
        for (i = 0; i < n; i++) {
            try  {
                img = ImageIO.read(new File(s[i]))  ;
            } catch(IOException e) {
                e.printStackTrace();
                System.out.println("Chyba obrazok c."+String.valueOf(i+1));
                return x;
            }
            Raster raster = img.getRaster();
            ColorModel colorModel = img.getColorModel();
            for(j = 0; j < height; j++) {
                l = j * width;
                for(k = 0; k < width; k++)
                    x[l + k][i] = (char)colorModel.getRed(raster.getDataElements(k,j,null));
            }
        }
        
        return x;
    }
    
    /**
     * Vrti poet pixelov obrzka, ktor m cestu v stringu s.
     */
    public static int getPixelCount(String name) {
        BufferedImage img = null;
        try {
            img = ImageIO.read(new File(name));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return img.getWidth() * img.getHeight();
    }
    
    /**
     * Vrti rku obrzka, ktor m cestu v stringu s.
     */
    public static int getWidth(String name) {
        BufferedImage obr = null;
        try {
            obr = ImageIO.read(new File(name));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return obr.getWidth();
    }
    
    /**
     * Vrti vku pixelov obrzka, ktor m cestu v stringu s.
     */
    public static int getHeight(String name) {
        BufferedImage obr = null;
        try {
            obr = ImageIO.read(new File(name));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return obr.getHeight();
    }
    
    //meno suboru je name+(j+1).png
    //v x musia byt hodnoty od 0 po 255, mozu byt realne
    /**
     * Zape na disk obrzok.
     * @param name Telo nzvu obrzku.
     * @param width rka obrzku
     * @param height vka obrzku
     * @param x pole v rovnakom tvare, aky vracia funkcia <CODE>loadImagesDouble</CODE>
     * @param j slo obrzka.
     */
    public static void saveOutput(String name, int width, int height, double[][] x, int j) {
        int i;
        int pixelCount = width * height;
        BufferedImage img = null;
        img = new BufferedImage(width, height, 1);
        for(i = 0; i < pixelCount; i++)
            img.setRGB(i % width, i / width, 65793 * (int)Math.round(x[i][j]));
        
        try {
            ImageIO.write(img,"bmp",new File(".\\"+name+String.valueOf(j+1)+".bmp"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        
    }
    
    /**
     * Nata obrzky zadan v poli s.
     * @param s Obsahuje cesty k jednotlivm obrzkom.
     * @return Vrti dvojrozmern pole typu double. Prv index oznauje slo obrzka, druh v druhom s jednotliv pixeli obrzka natan postupne po riadkoch. Hodnoty v poli s z rozsahu 0..255.
     */
    public static double[][] loadImagesDouble(String[] s) {
        
        int pixelCount; //pocet pixelov na obrazku a teda pocet vstupov
        int height ,width;
        BufferedImage img = null;
        try {
            img = ImageIO.read(new File(s[0]));
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("Vstup nenajdeny");
            System.exit(0);
        }
        height = img.getHeight();
        width = img.getWidth();
        pixelCount = height * width;
        int n = s.length;
        double x[][] = new double[pixelCount][n];
        int i, j, k, l;
        for (i = 0; i < n; i++) {
            try  {
                img = ImageIO.read(new File(s[i]))  ;
            } catch(IOException e) {
                e.printStackTrace();
                System.out.println("Chyba obrazok c."+String.valueOf(i+1));
                return x;
            }
            Raster raster = img.getRaster();
            ColorModel colorModel = img.getColorModel();
            for(j = 0; j < height; j++) {
                l = j * width;
                for(k = 0; k < width; k++)
                    x[l + k][i] = (char)colorModel.getRed(raster.getDataElements(k,j,null));
            }
        }
        
        return x;
    }
    
}
