/*
 * Preprocessing.java
 *
 * Created on Pondelok, 2007, aprl 30, 18:38
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package spectKonfo;

import Jama.*;

/**
 * V tejto triede s implementovan metdy na predspracovanie zvynch algoritmov. Kad metda m parameter dvojrozmern pole doublov. Prv sradnica uruje slo vektora, druh index vo vektore.
 * @author Kamil Paulny
 */
public class Preprocessing {
    
    /** Creates a new instance of PreP */
    public Preprocessing() {
    }
    private void centering(double x[][]) {
        int inputCount, n;
        inputCount = x.length;
        n = x[0].length;
        double E[] = new double[n];
        int i, j;
        for (i = 0; i < inputCount; i++)
            for (j = 0; j < n; j++)
                E[j] += x[i][j];
        
        for (j = 0; j < n; j++)
            E[j] = E[j] / inputCount;
        
        
        for (i = 0; i < inputCount; i++)
            for (j = 0; j < n; j++)
                x[i][j] -= E[j];
    }
    
    private Matrix whitening(double x[][]) {
        int inputCount, n;
        inputCount = x.length;
        n = x[0].length;
        Matrix cov = covarianceM(x);
        cov.print(0, 2);
        EigenvalueDecomposition evd=new EigenvalueDecomposition(cov);
        Matrix V = evd.getV();
        Matrix D = evd.getD();
        int i, j, k;
        for(i = 0; i < n; i++)
            D.set(i, i, 1 / Math.sqrt(D.get(i, i)));
        Matrix EDE = V.times(D.times(V.transpose()));
        double[][] ede = EDE.getArray();
        double[] xnew = new double[n];
        for(i = 0; i < inputCount; i++) {
            xnew = new double[n];
            for(j = 0; j < n; j++)
                for(k = 0; k < n; k++)
                    xnew[j] += ede[j][k] * x[i][k];
            for(j = 0; j < n; j++)
                x[i][j] = xnew[j];
        }
        return EDE;
    }
    
    
    /**
     * Vypota kovariann maticu
     * @param x
     */
    public Matrix covarianceM(double[][] x) {
        int inputCount, n;
        inputCount = x.length;
        n = x[0].length;
        int i, j, k;
        double cov[][] = new double[n][n];
        for(i = 0; i < inputCount; i++)
            for(j = 0; j < n; j++)
                for(k = 0; k < n; k++)
                    cov[j][k] += x[i][j] * x[i][k];
        for(j = 0; j < n; j++)
            for(k = 0 ; k < n; k++)
                cov[j][k] /= inputCount;
        return new Matrix(cov);
    }
    
    /**
     * Predspracovanie pre algoritmus FastICA
     */
    public Matrix fastICA(double x[][]) {
        centering(x);
        return whitening(x);
    }
    
    private void norm(double x[][]) {
        int inputCount, n;
        inputCount = x.length;
        n = x[0].length;
        int i, j;
        for (i = 0; i < inputCount; i++)
            for (j = 0; j < n; j++)
                x[i][j] /= 255;
    }
    
    /**
     * Predspracovanie pre algoritmus FastICA
     */
    public void Pca(double x[][]) {
        centering(x);
        norm(x);
    }
    
}
