/*
 * RandomUtils.java
 *
 * Created on Nedea, 2007, aprl 29, 14:28
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package spectKonfo;

import java.util.Random;

/**
 * Tto trieda obsahuje vetky potrebn typy generovania nhodnych sel.
 * @author Kamil Paulny
 */
public class RandomUtils {
    private static Random gen = new Random();
    /**
     *
     */
    public RandomUtils() {
    }
    
    /**
     * Vrti nhodn slo zo zadanho intervalu
     * @param from Doln hranica intervalu
     * @param to Horn hranica intervalu
     */
    public static double nextDoubleRange(double from, double to) {
        return from + (to - from) * gen.nextDouble();
    }
    
    /**
     * Vrti nhodn slo z intervalu 0..1
     */
    public static double nextDouble() {
        return gen.nextDouble();
    }
    
    /**
     * Vrti pole nhodnch sel z intervalu 0..1
     * @param n Rozmer poa
     */
    public static double[] nextDoubleArray(int n) {
        double[] a = new double[n];
        for(int i = 0; i < n; i++)
            a[i] = gen.nextDouble();
        return a;
    }
    
    /**
     * Vrti nhodn slo s Gaussovou distribciou pravdepodobnosti, s nulovou strednou hodnotou ajednotkovou disperziou
     */
    public static double nextGaussian() {
        return gen.nextGaussian();
    }
    
    /**
     * Vrti cele slo z intervalu 0..n-1(vrtane)
     */
    public static int nextInt(int n) {
        return gen.nextInt(n);
    }
}
